﻿using System;
using GCHR.Model;
using GCHR.Model.Konto;

namespace GCHR.Mandantenschnittstelle
{
    class Fiat : IMandant
    {
        private readonly Konfiguration _config = Konfiguration.GetInstance();

        public bool BalanceDatei
        {
            get
            {
                return true;
            }
        }

        public bool AccountsDatei
        {
            get
            {
                return true;
            }
        }

        public string BalanceHeader
        {
            get
            {
                return String.Format("AA{0} {1}{2} ,20EUR", _config.Haendlernummer, _config.AktuellePeriode.Monat, _config.AktuellePeriode.JahrZweistellig);
            }
        }

        public string BalanceFooter
        {
            get
            {
                return String.Format("XX{0} {1}{2}", _config.Haendlernummer, _config.AktuellePeriode.Monat, _config.AktuellePeriode.JahrZweistellig);
            }
        }

        public string BalanceBody(HaendlerKonto konto)
        {
            return KontonummerFormatieren(konto).PadRight(20, ' ') + String.Format("{0,18:0.00}", konto.Summe);
        }

        public string AccountsHeader
        {
            get
            {
                return "Account Code".PadRight(42, ' ') + "Description";
            }
        }

        public string AccountsFooter
        {
            get
            {
                return String.Empty;
            }
        }

        public string KontonummerFormatieren(HaendlerKonto konto)
        {
            return konto.Marke + konto.Betrieb + konto.Kontonummer;
        }

        public string AccountsBody(HaendlerKonto konto)
        {
            return KontonummerFormatieren(konto).PadRight(42, ' ') + konto.Bezeichnung;
        }
    }
}
