﻿using System;
using System.Text.RegularExpressions;
using GCHR.Model;
using GCHR.Model.Konto;

namespace GCHR.Mandantenschnittstelle
{
    class Peugeot : IMandant
    {
        private readonly Konfiguration _config = Konfiguration.GetInstance();

        public bool BalanceDatei
        {
            get
            {
                return true;
            }
        }

        public bool AccountsDatei
        {
            get
            {
                return false;
            }
        }

        public string BalanceHeader
        {
            get
            {
                return String.Format("01{0}{1}{2}{3}", _config.Haendlernummer.PadLeft(7, '0'), _config.Eurodatanummer, _config.AktuellePeriode.Monat, _config.AktuellePeriode.JahrZweistellig);
            }
        }

        public string BalanceFooter
        {
            get
            {
                return String.Empty;
            }
        }

        public string BalanceBody(HaendlerKonto konto)
        {
            return ("02" + KontonummerFormatieren(konto) +
                            Regex.Replace(String.Format("{0:0.00+;0.00+;0.00+}", konto.Soll), ",", "").PadLeft(13, '0') +
                            Regex.Replace(String.Format("{0:0.00+;0.00+;0.00+}", konto.Haben), ",", "").PadLeft(13, '0') +
                            "000000000000+" + "000000000000+");
        }

        public string AccountsHeader
        {
            get
            {
                return String.Empty;
            }
        }

        public string AccountsBody(HaendlerKonto konto)
        {
            return String.Empty;
        }

        public string AccountsFooter
        {
            get
            {
                return String.Empty;
            }
        }

        public string KontonummerFormatieren(HaendlerKonto konto)
        {
            return konto.Marke + konto.Betrieb + konto.Kontonummer;
        }
    }
}
