﻿using System;
using System.IO;
using System.Xml.Serialization;
using GCHR.Control;
using GCHR.Mandantenschnittstelle;
using GCHR.Model;
using NUnit.Framework;

namespace GCHR.Tests
{
    [TestFixture]
    public class KonfigurationTest
    {
        private static string PfadUndDatei(string dateiOhneEndung)
        {
            return Directory.GetCurrentDirectory() + "\\config\\" + dateiOhneEndung + ".xml";
        }

        private static Konfiguration KonfigurationLaden(string test)
        {
            return new Konfiguration(PfadUndDatei(test));
        }

        [Test]
        public void DateiMitStandardwertenAnlegen()
        {
            var datei = PfadUndDatei("standard");
            File.Delete(datei);
            var config = new Konfiguration(datei);
            
            Assert.IsTrue(File.Exists(datei));
            Assert.AreEqual("Autohaus", config.Haendler);
            Assert.AreEqual(Mandanten.Opel, config.Mandantenname);
            Assert.AreEqual(5, config.HerstellerKontenrahmenStellen);
            Assert.AreEqual(5, config.HaendlerKontenrahmenStellen);
            Assert.AreEqual("0", config.BilanzMarke);
            Assert.AreEqual("07", config.BilanzBetrieb);
            Assert.IsFalse(config.KontoOhneUebersetzungUebernehmen);
            Assert.IsTrue(config.StatKontenImportieren);
            Assert.AreEqual("01", config.Geschaeftsjahr);

            Assert.AreEqual("DSN=O21;UID=sa;PWD=;", config.OdbcConnectionString);
        }
    }
}
